Index: trunk/src/VBox/Frontends/VirtualBox4/VirtualBox.qrc
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/VirtualBox.qrc	(revision 13545)
+++ trunk/src/VBox/Frontends/VirtualBox4/VirtualBox.qrc	(revision 13553)
@@ -131,5 +131,7 @@
     <file alias="guesttools_16px.png">images/guesttools_16px.png</file>
     <file alias="guesttools_disabled_16px.png">images/guesttools_disabled_16px.png</file>
-    <file alias="diskim_16px.png">images/diskim_16px.png</file>
+    <file alias="diskimage_16px.png">images/diskimage_16px.png</file>
+    <file alias="diskimage_32px.png">images/diskimage_32px.png</file>
+    <file alias="diskimage_disabled_32px.png">images/diskimage_disabled_32px.png</file>
     <file alias="settings_16px.png">images/settings_16px.png</file>
     <file alias="delete_16px.png">images/delete_16px.png</file>
@@ -244,4 +246,8 @@
     <file alias="edit_description_16px.png">images/edit_description_16px.png</file>
     <file alias="edit_description_disabled_16px.png">images/edit_description_disabled_16px.png</file>
+    <file alias="session_info_16px.png">images/session_info_16px.png</file>
+    <file alias="session_info_disabled_16px.png">images/session_info_disabled_16px.png</file>
+    <file alias="session_info_32px.png">images/session_info_32px.png</file>
+    <file alias="session_info_disabled_32px.png">images/session_info_disabled_32px.png</file>
     <file alias="global_settings_16px.png">images/global_settings_16px.png</file>
     <file alias="global_settings_disabled_16px.png">images/global_settings_disabled_16px.png</file>
Index: trunk/src/VBox/Frontends/VirtualBox4/src/VBoxConsoleWnd.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/src/VBoxConsoleWnd.cpp	(revision 13545)
+++ trunk/src/VBox/Frontends/VirtualBox4/src/VBoxConsoleWnd.cpp	(revision 13553)
@@ -231,5 +231,5 @@
     vmShowInformationDlgAction = new QAction (this);
     vmShowInformationDlgAction->setIcon (VBoxGlobal::iconSet (
-        ":/description_16px.png", ":/description_disabled_16px.png"));
+        ":/session_info_16px.png", ":/session_info_disabled_16px.png"));
 
     vmDisableMouseIntegrAction = new QAction (this);
Index: trunk/src/VBox/Frontends/VirtualBox4/src/VBoxDiskImageManagerDlg.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/src/VBoxDiskImageManagerDlg.cpp	(revision 13545)
+++ trunk/src/VBox/Frontends/VirtualBox4/src/VBoxDiskImageManagerDlg.cpp	(revision 13553)
@@ -231,4 +231,8 @@
     /* Apply UI decorations */
     Ui::VBoxDiskImageManagerDlg::setupUi (this);
+
+    /* Apply window icons */
+    setWindowIcon (vboxGlobal().iconSetFull (QSize (32, 32), QSize (16, 16),
+                                             ":/diskimage_32px.png", ":/diskimage_16px.png"));
 
     mVBox = vboxGlobal().virtualBox();
Index: trunk/src/VBox/Frontends/VirtualBox4/src/VBoxSelectorWnd.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/src/VBoxSelectorWnd.cpp	(revision 13545)
+++ trunk/src/VBox/Frontends/VirtualBox4/src/VBoxSelectorWnd.cpp	(revision 13553)
@@ -279,5 +279,5 @@
     mBtnEdit->setFocusPolicy (Qt::StrongFocus);
     mBtnEdit->setIcon (VBoxGlobal::iconSet (":/edit_description_16px.png",
-                                               ":/edit_description_disabled_16px.png"));
+                                            ":/edit_description_disabled_16px.png"));
     mBtnEdit->setToolButtonStyle (Qt::ToolButtonTextBesideIcon);
     connect (mBtnEdit, SIGNAL (clicked()), this, SLOT (goToSettings()));
@@ -403,5 +403,5 @@
 
     fileDiskMgrAction = new QAction (this);
-    fileDiskMgrAction->setIcon (VBoxGlobal::iconSet (":/diskim_16px.png"));
+    fileDiskMgrAction->setIcon (VBoxGlobal::iconSet (":/diskimage_16px.png"));
     fileSettingsAction = new QAction(this);
     fileSettingsAction->setMenuRole (QAction::PreferencesRole);
Index: trunk/src/VBox/Frontends/VirtualBox4/src/VBoxVMInformationDlg.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/src/VBoxVMInformationDlg.cpp	(revision 13545)
+++ trunk/src/VBox/Frontends/VirtualBox4/src/VBoxVMInformationDlg.cpp	(revision 13553)
@@ -73,4 +73,8 @@
      * which isn't necessary here. */
     setWindowIcon (QIcon());
+#else
+    /* Apply window icons */
+    setWindowIcon (vboxGlobal().iconSetFull (QSize (32, 32), QSize (16, 16),
+                                             ":/session_info_32px.png", ":/session_info_16px.png"));
 #endif
 
Index: trunk/src/VBox/Frontends/VirtualBox4/src/VBoxVMLogViewer.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/src/VBoxVMLogViewer.cpp	(revision 13545)
+++ trunk/src/VBox/Frontends/VirtualBox4/src/VBoxVMLogViewer.cpp	(revision 13553)
@@ -76,4 +76,8 @@
     /* Apply UI decorations */
     Ui::VBoxVMLogViewer::setupUi (this);
+
+    /* Apply window icons */
+    setWindowIcon (vboxGlobal().iconSetFull (QSize (32, 32), QSize (16, 16),
+                                             ":/vm_show_logs_32px.png", ":/show_logs_16px.png"));
 
     /* Enable size grip without using a status bar. */
Index: trunk/src/VBox/Frontends/VirtualBox4/ui/VBoxDiskImageManagerDlg.ui
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/ui/VBoxDiskImageManagerDlg.ui	(revision 13545)
+++ trunk/src/VBox/Frontends/VirtualBox4/ui/VBoxDiskImageManagerDlg.ui	(revision 13553)
@@ -35,7 +35,4 @@
   <property name="windowTitle" >
    <string>Virtual Disk Manager</string>
-  </property>
-  <property name="windowIcon" >
-   <iconset resource="../VirtualBox.qrc" >:/diskim_16px.png</iconset>
   </property>
   <widget class="QWidget" name="mCentralWidget" >
Index: trunk/src/VBox/Frontends/VirtualBox4/ui/VBoxVMInformationDlg.ui
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/ui/VBoxVMInformationDlg.ui	(revision 13545)
+++ trunk/src/VBox/Frontends/VirtualBox4/ui/VBoxVMInformationDlg.ui	(revision 13553)
@@ -29,7 +29,4 @@
   <property name="windowTitle" >
    <string>VBoxVMInformationDlg</string>
-  </property>
-  <property name="windowIcon" >
-   <iconset resource="../VirtualBox.qrc" >:/description_16px.png</iconset>
   </property>
   <widget class="QWidget" name="centralwidget" >
Index: trunk/src/VBox/Frontends/VirtualBox4/ui/VBoxVMLogViewer.ui
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/ui/VBoxVMLogViewer.ui	(revision 13545)
+++ trunk/src/VBox/Frontends/VirtualBox4/ui/VBoxVMLogViewer.ui	(revision 13553)
@@ -29,7 +29,4 @@
   <property name="windowTitle" >
    <string>Log Viewer</string>
-  </property>
-  <property name="windowIcon" >
-   <iconset resource="../VirtualBox.qrc" >:/show_logs_16px.png</iconset>
   </property>
   <widget class="QWidget" name="centralwidget" >