Index: trunk/src/VBox/Frontends/VirtualBox4/include/VBoxGlobal.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/include/VBoxGlobal.h	(revision 13599)
+++ trunk/src/VBox/Frontends/VirtualBox4/include/VBoxGlobal.h	(revision 13601)
@@ -741,5 +741,5 @@
 #endif
 
-    void checkForAutoConvertedSettings();
+    bool checkForAutoConvertedSettings();
 
     CSession openSession (const QUuid &aId, bool aExisting = false);
Index: trunk/src/VBox/Frontends/VirtualBox4/src/VBoxGlobal.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/src/VBoxGlobal.cpp	(revision 13599)
+++ trunk/src/VBox/Frontends/VirtualBox4/src/VBoxGlobal.cpp	(revision 13601)
@@ -2553,7 +2553,7 @@
 /**
  * Checks if any of the settings files were auto-converted and informs the user
- * if so.
- */
-void VBoxGlobal::checkForAutoConvertedSettings()
+ * if so. Returns @c false if the user select to exit the application.
+ */
+bool VBoxGlobal::checkForAutoConvertedSettings()
 {
     QString formatVersion = mVBox.GetSettingsFormatVersion();
@@ -2575,5 +2575,6 @@
         {
             machines.append (*m);
-            fileList += QString ("<nobr>%1&nbsp;&nbsp;&nbsp;(<i>%2</i>)</nobr><br>")
+            fileList += QString ("<tr><td><nobr>%1</nobr></td><td>&nbsp;&nbsp;</td>"
+                                 "</td><td><nobr><i>%2</i></nobr></td></tr>")
                 .arg (m->GetSettingsFilePath())
                 .arg (version);
@@ -2585,49 +2586,56 @@
     {
         isGlobalConverted = true;
-        fileList += QString ("<nobr>%1&nbsp;&nbsp;&nbsp;(<i>%2</i>)</nobr><br>")
+        fileList += QString ("<tr><td><nobr>%1</nobr></td><td>&nbsp;&nbsp;</td>"
+                             "</td><td><nobr><i>%2</i></nobr></td></tr>")
             .arg (mVBox.GetSettingsFilePath())
             .arg (version);
     }
 
-
     if (!fileList.isNull())
     {
+        fileList = QString ("<table cellspacing=0 cellpadding=0>%1</table>")
+                            .arg (fileList);
+
         int rc = vboxProblem()
             .warnAboutAutoConvertedSettings (formatVersion, fileList);
 
-        if (rc == QIMessageBox::No || rc == QIMessageBox::Yes)
-        {
-            /* backup (optionally) and save all settings files
-             * (QIMessageBox::No = Backup, QIMessageBox::Yes = Save) */
-
-            foreach (CMachine m, machines)
+        if (rc == QIMessageBox::Cancel)
+            return false;
+
+        Assert (rc == QIMessageBox::No || rc == QIMessageBox::Yes);
+
+        /* backup (optionally) and save all settings files
+         * (QIMessageBox::No = Backup, QIMessageBox::Yes = Save) */
+
+        foreach (CMachine m, machines)
+        {
+            CSession session = openSession (m.GetId());
+            if (!session.isNull())
             {
-                CSession session = openSession (m.GetId());
-                if (!session.isNull())
-                {
-                    CMachine sm = session.GetMachine();
-                    if (rc == QIMessageBox::No)
-                        sm.SaveSettingsWithBackup();
-                    else
-                        sm.SaveSettings();
-
-                    if (!sm.isOk())
-                        vboxProblem().cannotSaveMachineSettings (sm);
-                    session.Close();
-                }
+                CMachine sm = session.GetMachine();
+                if (rc == QIMessageBox::No)
+                    sm.SaveSettingsWithBackup();
+                else
+                    sm.SaveSettings();
+
+                if (!sm.isOk())
+                    vboxProblem().cannotSaveMachineSettings (sm);
+                session.Close();
             }
-
-            if (isGlobalConverted)
-            {
-                if (rc == QIMessageBox::No)
-                    mVBox.SaveSettingsWithBackup();
-                else
-                    mVBox.SaveSettings();
-
-                if (!mVBox.isOk())
-                    vboxProblem().cannotSaveGlobalSettings (mVBox);
-            }
-        }
-    }
+        }
+
+        if (isGlobalConverted)
+        {
+            if (rc == QIMessageBox::No)
+                mVBox.SaveSettingsWithBackup();
+            else
+                mVBox.SaveSettings();
+
+            if (!mVBox.isOk())
+                vboxProblem().cannotSaveGlobalSettings (mVBox);
+        }
+    }
+
+    return true;
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox4/src/VBoxProblemReporter.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/src/VBoxProblemReporter.cpp	(revision 13599)
+++ trunk/src/VBox/Frontends/VirtualBox4/src/VBoxProblemReporter.cpp	(revision 13601)
@@ -1827,5 +1827,5 @@
 /**
  * Shows a list of auto-converted files and asks the user to either Save, Backup
- * or Cancel to leave them as is.
+ * or Cancel to leave them as is and exit VirtualBox.
  *
  * @param aFormatVersion    Recent settings file format version.
@@ -1833,10 +1833,35 @@
  *
  * @return QIMessageBox::Yes (Save), QIMessageBox::No (Backup),
- *         QIMessageBox::Cancel (Leave)
+ *         QIMessageBox::Cancel (Exit)
  */
 int VBoxProblemReporter::warnAboutAutoConvertedSettings (const QString &aFormatVersion,
                                                          const QString &aFileList)
 {
-    return message (mainWindowShown(), Warning,
+    int rc = message (mainWindowShown(), Info,
+        tr ("<p>Your existing VirtualBox settings files were automatically "
+            "converted from the old format to a new format necessary for the "
+            "new version of VirtualBox.</p>"
+            "<p>Press <b>OK</b> to start VirtualBox now or press <b>More</b> if "
+            "you want to get more information about what files were converted "
+            "and access additional actions.</p>"
+            "<p>Press <b>Exit</b> to terminate the VirtualBox "
+            "application without saving the results of the conversion to "
+            "disk.</p>"),
+        NULL /* aAutoConfirmId */,
+        QIMessageBox::Ok | QIMessageBox::Default,
+        QIMessageBox::No,
+        QIMessageBox::Cancel | QIMessageBox::Escape,
+        0,
+        tr ("&More", "warnAboutAutoConvertedSettings message box"),
+        tr ("E&xit", "warnAboutAutoConvertedSettings message box"));
+
+    /* in the simplest case we backup */
+    if (rc == QIMessageBox::Ok)
+        return QIMessageBox::No;
+
+    if (rc == QIMessageBox::Cancel)
+        return QIMessageBox::Cancel;
+
+    return message (mainWindowShown(), Info,
         tr ("<p>The following VirtualBox settings files have been "
             "automatically converted to the new settings file format "
@@ -1845,16 +1870,18 @@
             "to disk yet. Please press:</p>"
             "<ul>"
-            "<li><b>Save</b> to save all auto-converted files now (it will not "
-            "be possible to use these settings files with an older version of "
-            "VirtualBox in the future);</li>"
             "<li><b>Backup</b> to create backup copies of the settings files in "
             "the old format before saving them in the new format;</li>"
-            "<li><b>Cancel</b> to not save the auto-converted settings files "
-            "now.<li>"
+            "<li><b>Overwrite</b> to save all auto-converted files without "
+            "creating backup copies (it will not be possible to use these "
+            "settings files with an older version of VirtualBox "
+            "afterwards);</li>"
+            "<li><b>Exit</b> to terminate VirtualBox without saving the "
+            "results of the conversion to disk.</li>"
             "</ul>"
-            "<p>Note that if you select <b>Cancel</b>, the auto-converted "
-            "settings files will be implicitly saved in the new format anyway "
-            "once you change a setting or start a virtual machine, but "
-            "<b>no</b> backup copies will be created in this case.</p>")
+            "<p>It is recommended to always select <b>Backup</b> because in "
+            "this case it will be possible to go back to the previous "
+            "version of VirtualBox (if necessary) without losing your current "
+            "settings. See the VirtualBox Manual for more information about "
+            "downgrading.</p>")
             .arg (aFormatVersion),
         aFileList,
@@ -1863,7 +1890,7 @@
         QIMessageBox::No | QIMessageBox::Default,
         QIMessageBox::Cancel | QIMessageBox::Escape,
-        tr ("&Save", "warnAboutAutoConvertedSettings message box"),
+        tr ("O&verwrite", "warnAboutAutoConvertedSettings message box"),
         tr ("&Backup", "warnAboutAutoConvertedSettings message box"),
-        tr ("Cancel", "warnAboutAutoConvertedSettings message box"));
+        tr ("E&xit", "warnAboutAutoConvertedSettings message box"));
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox4/src/main.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/src/main.cpp	(revision 13599)
+++ trunk/src/VBox/Frontends/VirtualBox4/src/main.cpp	(revision 13601)
@@ -341,5 +341,6 @@
 #endif
 
-            vboxGlobal().checkForAutoConvertedSettings();
+            if (!vboxGlobal().checkForAutoConvertedSettings())
+                break;
 
             VBoxGlobalSettings settings = vboxGlobal().settings();