Index: trunk/src/VBox/Frontends/VirtualBox4/include/VBoxUtils.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/include/VBoxUtils.h	(revision 13603)
+++ trunk/src/VBox/Frontends/VirtualBox4/include/VBoxUtils.h	(revision 13631)
@@ -27,5 +27,5 @@
 #include <QMouseEvent>
 #include <QWidget>
-#include <QTextEdit>
+#include <QTextBrowser>
 
 /**
@@ -108,4 +108,21 @@
 };
 
+/**
+ *  QTextBrowser reimplementation to feat some extended requirements.
+ */
+class QRichTextBrowser : public QTextBrowser
+{
+    Q_OBJECT;
+
+public:
+
+    QRichTextBrowser (QWidget *aParent) : QTextBrowser (aParent) {}
+
+    void setViewportMargins (int aLeft, int aTop, int aRight, int aBottom)
+    {
+        QTextBrowser::setViewportMargins (aLeft, aTop, aRight, aBottom);
+    }
+};
+
 #ifdef Q_WS_MAC
 # undef PAGE_SIZE
Index: trunk/src/VBox/Frontends/VirtualBox4/src/VBoxSelectorWnd.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/src/VBoxSelectorWnd.cpp	(revision 13603)
+++ trunk/src/VBox/Frontends/VirtualBox4/src/VBoxSelectorWnd.cpp	(revision 13631)
@@ -33,4 +33,5 @@
 #include "VBoxVMLogViewer.h"
 #include "VBoxGlobal.h"
+#include "VBoxUtils.h"
 
 #ifdef Q_WS_X11
@@ -101,5 +102,5 @@
     void createErrPage();
 
-    QTextBrowser *mDetailsText;
+    QRichTextBrowser *mDetailsText;
 
     QWidget *mErrBox;
@@ -121,5 +122,6 @@
     /* create normal details page */
 
-    mDetailsText = new QTextBrowser (mErrBox);
+    mDetailsText = new QRichTextBrowser (mErrBox);
+    mDetailsText->setViewportMargins (10, 10, 10, 10);
     mDetailsText->setFocusPolicy (Qt::StrongFocus);
     mDetailsText->document()->setDefaultStyleSheet ("a { text-decoration: none; }");
@@ -454,20 +456,24 @@
     mHelpActions.setup (this);
 
-    /* subwidgets */
-
-    /* central widget & horizontal layout */
+    /* Subwidgets */
+
+    /* Central widget @ vertical layout */
     setCentralWidget (new QWidget (this));
-    QHBoxLayout *centralLayout =
-        new QHBoxLayout (centralWidget());
-
-    /* left vertical box */
-    QVBoxLayout *leftVLayout = new QVBoxLayout ();
-    /* right vertical box */
-    QVBoxLayout *rightVLayout = new QVBoxLayout ();
-    centralLayout->addLayout (leftVLayout, 1);
-    centralLayout->addLayout (rightVLayout, 2);
+    QVBoxLayout *centralLayout = new QVBoxLayout (centralWidget());
+
+    /* Pane horizontal layout */
+    QHBoxLayout *paneLayout = new QHBoxLayout();
 
     /* VM list toolbar */
     VBoxToolBar *vmTools = new VBoxToolBar (this);
+
+    /* Left vertical box */
+    QVBoxLayout *leftVLayout = new QVBoxLayout();
+    paneLayout->addLayout (leftVLayout, 1);
+
+    /* Right vertical box */
+    QVBoxLayout *rightVLayout = new QVBoxLayout();
+    paneLayout->addLayout (rightVLayout, 2);
+
 #if MAC_LEOPARD_STYLE
     /* Enable unified toolbars on Mac OS X. Available on Qt >= 4.3 */
@@ -476,10 +482,12 @@
     /* No spacing/margin on the mac */
     VBoxGlobal::setLayoutMargin (centralLayout, 0);
+    VBoxGlobal::setLayoutMargin (paneLayout, 0); /* Dsen to NaN: Is it necessary? */
     leftVLayout->setSpacing (0);
     rightVLayout->setSpacing (0);
-    rightVLayout->insertSpacing (0, 10);
+    // rightVLayout->insertSpacing (0, 10); /* Dsen to NaN: Is it necessary anymore? */
 #else /* MAC_LEOPARD_STYLE */
-    leftVLayout->addWidget(vmTools);
-    centralLayout->setSpacing (9);
+    centralLayout->addWidget (vmTools);
+    centralLayout->setSpacing (5);
+    paneLayout->setSpacing (9);
     VBoxGlobal::setLayoutMargin (centralLayout, 5);
     leftVLayout->setSpacing (5);
@@ -487,7 +495,10 @@
 #endif /* MAC_LEOPARD_STYLE */
 
+    /* Inserting pane layout */
+    centralLayout->addLayout (paneLayout);
+
     /* VM list view */
     mVMListView = new VBoxVMListView();
-    mVMModel = new VBoxVMModel(mVMListView);
+    mVMModel = new VBoxVMModel (mVMListView);
     mVMListView->setModel (mVMModel);
 
@@ -495,14 +506,12 @@
 
     /* VM tab widget containing details and snapshots tabs */
-    vmTabWidget = new QTabWidget ();
+    vmTabWidget = new QTabWidget();
     rightVLayout->addWidget (vmTabWidget);
 
     /* VM details view */
-    vmDetailsView = new VBoxVMDetailsView (NULL,
-                                           vmRefreshAction);
+    vmDetailsView = new VBoxVMDetailsView (NULL, vmRefreshAction);
     vmTabWidget->addTab (vmDetailsView,
                          VBoxGlobal::iconSet (":/settings_16px.png"),
                          QString::null);
-    vmDetailsView->setContentsMargins (10, 10, 10, 10);
 
     /* VM snapshots list */
@@ -535,4 +544,10 @@
     vmTools->addAction (vmStartAction);
     vmTools->addAction (vmDiscardAction);
+    vmTools->addSeparator();
+    vmTools->addAction (vmPauseAction);
+    vmTools->addSeparator();
+    vmTools->addAction (vmRefreshAction);
+    vmTools->addSeparator();
+    vmTools->addAction (vmShowLogsAction);
 
     /* add actions to menubar */